﻿using System;
using System.Collections.Generic;
using System.Text;

namespace SimpleSort
{
    public static class SimpleSort
    {

        public static void Sort(SortData sData)
        {

            int temp;
            for (int i = sData.Left; i < sData.Right - 1; i++)
            {
                for (int j = i; j < sData.Right; j++)
                {
                    if (sData.ArrayOfInts[j] < sData.ArrayOfInts[i])
                    {
                        temp = sData.ArrayOfInts[j];
                        sData.ArrayOfInts[j] = sData.ArrayOfInts[i];
                        sData.ArrayOfInts[i] = temp;
                    }
                }
            }
        }

        public static int[] Merge(SortData sData)
        {
            int[] arrayOut = new int[sData.Size];
            int countOut = 0;
            int ind1, ind2;
            int count1 = sData.Left;
            int count2 = sData.Middle;
            while (count1 < sData.Middle)
            {
                if (sData.ArrayOfInts[count1] < sData.ArrayOfInts[count2])
                {
                    arrayOut[countOut++] = sData.ArrayOfInts[count1++];
                    if (count1 >= sData.Middle)
                        //left part is finished, rewrite rest of data
                        for (ind2 = count2; ind2 < sData.Right; ind2++)
                        {
                            arrayOut[countOut++] = sData.ArrayOfInts[ind2];
                        }
                }
                else
                {
                    arrayOut[countOut++] = sData.ArrayOfInts[count2++];
                    if (count2 >= sData.Right) //rest of numbers can be rewrite direct
                    {
                        for (ind1 = count1; ind1 < sData.Middle; ind1++)
                        {
                            arrayOut[countOut++] = sData.ArrayOfInts[ind1];
                        }
                        count1 = sData.Middle; //indicate that is finish
                    }
                }
            }
            sData.ArrayOfInts = arrayOut;
            return arrayOut;
        }
    }
}
